`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/09/2020 05:42:38 PM
// Design Name: 
// Module Name: Lab7_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab7_2(
    f_crystal,
    rst,
    show_year,
    ssd_ctl,
    D_ssd,
    speedup_1,
    speedup_2,
    speedup_3,
    show_sec,
    mode7_1,
    clock_or_calender
    );
    input f_crystal, rst, show_year, speedup_1, speedup_2, speedup_3, show_sec, mode7_1, clock_or_calender;
    output [3:0]ssd_ctl;
    output reg [7:0]D_ssd;
    
    wire [3:0]day_0, day_1, month_0, month_1, year_0, year_1;
    wire clk_1, clk_10, clk_100, clk_1000, clk_10000, clk_100000, clk_500000;
    wire [1:0]ssd_clk;
    reg [3:0]disp_0, disp_1, disp_2, disp_3;
    reg count_frq;
    wire [2:0]speedup;
    wire [3:0]display;
    wire point;
    wire [7:0]D_ssd_1, D_ssd_2;
    wire carry_to_day;
    frq_div U0(
    .f_out(clk_1), // divided clock output
    .clk_100(clk_100),
    .clk_10(clk_10),
    .clk_1000(clk_1000),
    .clk_10000(clk_10000),
    .clk_100000(clk_100000),
    .clk_500000(clk_500000),
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(rst) // active low reset
    );
    
    assign speedup = {speedup_3, speedup_2, speedup_1};
    
    always @*
        if(speedup == 3'b000)
            count_frq = clk_1;
        else if(speedup == 3'b001)
            count_frq = clk_10;
        else if(speedup == 3'b010)
            count_frq = clk_100;
        else if(speedup == 3'b011)
            count_frq = clk_1000;
        else if(speedup == 3'b100)
            count_frq = clk_10000;
        else if(speedup == 3'b101)
            count_frq = clk_100000;
        else if(speedup == 3'b110)
           count_frq = clk_500000;
        else
            count_frq = f_crystal;
    always @*
        if(show_year)
            begin
                disp_0 = year_0;
                disp_1 = year_1;
                disp_2 = 4'd0;
                disp_3 = 4'd0;
            end
        else
            begin
                disp_0 = day_0;
                disp_1 = day_1;
                disp_2 = month_0;
                disp_3 = month_1;
            end
    Date U1(
    .clk(count_frq),
    .increase(carry_to_day),
    .reset(rst),
    .day_0(day_0),
    .day_1(day_1),
    .month_0(month_0),
    .month_1(month_1),
    .year_0(year_0),
    .year_1(year_1)
    );
    scan_ctl U2(
      .ssd_ctl(ssd_ctl), // ssd display control signal 
      .ssd_in0(disp_0), // output to ssd display
      .ssd_in1(disp_1),
      .ssd_in2(disp_2),
      .ssd_in3(disp_3),
      .ssd_in(display),
      .ssd_ctl_clk(ssd_clk),
      .point(point)  
    );
    Display_7_segment U7_2(.D_ssd(D_ssd_2), .i(display), .point(point));
    
    Lab7_1 U4(
    .f_crystal(f_crystal),
    .rst(rst),
    .show_sec(show_sec),
    .D_ssd(D_ssd_1),
    .mode(mode7_1),
    .count_frq(count_frq),
    .ssd_clk(ssd_clk),
    .carry_to_day(carry_to_day)
    );
    
    always @*
        if(clock_or_calender == 0)
            D_ssd = D_ssd_2;
        else
            D_ssd = D_ssd_1;
    


endmodule
