`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/21/2020 02:35:20 PM
// Design Name: 
// Module Name: Lab3_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


`define FREQ_DIV_BIT 27
module frq_div(
f_out, // divided clock output
clk_100,
clk_10,
clk_1000,
ssd_clk,
f_crystal, // global clock input
rst // active low reset
);
output f_out; // divided output
input f_crystal; // global clock input
input rst; // active low reset
output reg [1:0]ssd_clk;
output reg clk_100;
output reg clk_10;
output reg clk_1000;
reg f_out; // clk output (in always block)
reg [`FREQ_DIV_BIT-1:0] ctl; // control signal to check if it's counted tp 50M
reg [`FREQ_DIV_BIT-1:0] cnt_tmp; 
reg [`FREQ_DIV_BIT-1:0] tmp1;
reg [`FREQ_DIV_BIT-1:0] tmp2; 
reg [1:0] clk_ctl;
reg [14:0]cnt_l;
reg [9:0]cnt_h;

reg [19:0]ctl_100; 
reg [19:0]tmp_ctl_100;
reg tmp_clk_100;

reg[22:0]ctl_10;
reg[22:0]tmp_ctl_10;
reg tmp_clk_10;

reg[17:0]ctl_1000;
reg[17:0]tmp_ctl_1000;
reg tmp_clk_1000;
always @*
{cnt_h, clk_ctl, cnt_l} = ctl;
// Combinational logics: increment, neglecting overflow
always @*
cnt_tmp = ctl + 1'b1;

always @*
if(ctl_10 == 23'd5_000_000)
    begin
        tmp_clk_10 = ~clk_10;
        tmp_ctl_10 = 23'd0;
    end
else
   begin
        tmp_clk_10 = clk_10; 
        tmp_ctl_10 = ctl_10+1;
   end   
   
always @*
   if(ctl_1000 == 18'd5_00_00)
       begin
           tmp_clk_1000 = ~clk_1000;
           tmp_ctl_1000 = 18'd0;
       end
   else
      begin
           tmp_clk_1000 = clk_1000; 
           tmp_ctl_1000 = ctl_1000+1;
      end       

always @*
if(ctl_100 == 20'd500_000)
    begin
        tmp_clk_100 = ~clk_100;
        tmp_ctl_100 = 20'd0;
    end
else
   begin
        tmp_clk_100 = clk_100; 
        tmp_ctl_100 = ctl_100+1;
   end     
always @*
   if(ctl == 50'd50_000_000)
       begin
           tmp2 = ~f_out;
           tmp1 = 27'd0;
       end
   else
      begin
           tmp2 = f_out; 
           tmp1 = cnt_tmp;
           ssd_clk = clk_ctl;
      end     
// Sequential logics: Flip flops
always @(posedge f_crystal or posedge rst)
if (rst) 
    begin
        ctl <= 27'd0;
        f_out <= 0;
    end
else 
    begin
        ctl <=  tmp1;
        f_out <= tmp2;
    end
    
always @(posedge f_crystal or posedge rst)
    if (rst) 
        begin
            ctl_100 <= 20'd0;
            clk_100 <= 0;
        end
    else 
        begin
            ctl_100 <=  tmp_ctl_100;
            clk_100 <= tmp_clk_100;
        end
        
always @(posedge f_crystal or posedge rst)
    if (rst) 
        begin
            ctl_10 <= 23'd0;
            clk_10 <= 0;
        end
    else 
        begin
            ctl_10 <=  tmp_ctl_10;
            clk_10 <= tmp_clk_10;
        end
        
 always @(posedge f_crystal or posedge rst)
        if (rst) 
            begin
                ctl_1000 <= 18'd0;
                clk_1000 <= 0;
            end
        else 
            begin
                ctl_1000 <=  tmp_ctl_1000;
                clk_1000 <= tmp_clk_1000;
            end
        
endmodule


    
